/**
 * 广点通移动广告SDK - 主引擎
 * @version 1.2
 * @author damonpeng@tencent.com
 */
/* 注入内容
<html><head><script src='http://qzonestyle.gtimg.cn/qzone/biz/gdt/mob/sdk/1.2/sdk.js'></script></head><body>
<script>GDTMOB.loadAd({
	uid	: 0,		// 设备id
	md	: 0,		// 机型
	mv	: 0,		// 市场版本
	lg	: 0,		// 语言
	w	: 0,		// 设备宽
	h	: 0,		// 设备高
	so	: 0,		// 设备横竖屏
	an	: 0,		// app名称
	dd	: 0,		// 设备密度
	pn	: 0,		// 手机网络
	dn	: 0,		// 数据网络
	op	: 0,		// 运营商
	did	: 0,		// md5后的IMEI
	apil: 0,		// Android API level
	adw	: 0,		// 广告宽
	adh	: 0,		// 广告高
	pubid: 0,		// publish ID
	posid: 0,		// 广告位id
	adtype: 0,		// 广告类型  banner=mb, appwall=maw
	testad: 0,		// 是否测试广告
	rf	: 0,		// refresh frequency
	lac	: 0,		// 基站lac
	cellid: 0,		// 基站cellid
	neighborings: {lac:'', cellid:'', rssi: '强弱'},  // 邻区
	sdkv: 0			// sdk版本号，浮点数
})</script>
</body></html>
 */
(function(GDTMOB){
	var MB = {};

	// 当前js版本号
	GDTMOB.version = 1.2;

	// 所有合法入参
	MB._params = null;

	/**
	 * 创建JS与Client的gdtmsg通信器
	 * @return {object} 
	 */
	MB._sender = null;
	MB._getMessageSender = function() {
		var ifr;

		// 不存在则创建
		if (! (ifr=MB._sender)) {
			ifr = document.createElement('iframe');
			MB._sender = ifr;
			ifr.id = 'gdtmob-notify-' + (new Date()).getTime();
			ifr.style.display = 'none';
		}

		return ifr;
	};

	/**
	 * JS与Client的通信
	 * @param  {string} action 行为
	 * @param  {string} msg 需要传递的信息串
	 * @return {undefiend} 
	 */
	MB._sendMessage = function(action, params) {
		var requestUrl, ps,
			sender = MB._getMessageSender();

		ps = typeof params==='object' ? MB._genHTTPParams(params) : '';

		requestUrl = 'gdtmsg://e.qq.com/'+ action + (ps ? '?' : '') + ps;
		sender.src = requestUrl;

		// @todo 队列

		sender.parentNode || document.body.appendChild(sender);
	};

	/**
	 * 生成请求串
	 * @param  {object} params	参数
	 * @return {string}     	请求串
	 */
	MB._genHTTPParams = function(params) {
		var req = [];

		for(var p in params) {
			req.push(p +'='+ encodeURIComponent(params[p]));
		}

		return req.join('&');
	};

	/**
	 * 参数过滤，不是所有客户端的参数都发送
	 * @param  {[type]} params [description]
	 * @return {[type]}        [description]
	 */
	MB._paramsFilter = function(params) {
		if (typeof params !== 'object') {
			throw 'Error Params from Native SDK.';
		}

		// 当前js版本号
		params.jsv = GDTMOB.version;

		return params;
	};

	/**
	 * 根据广告尺寸适配到对应广告位
	 * @param  {int} width
	 * @param  {int} height
	 * @return {int} 广告位id
	 */
	MB._adsizeAdapter = function(params) {
		var width, height, dpi, sdkv,
			adsize, mapping, wpx, hpx, sdkv;

		width	= parseInt(params.adw, 10);
		height	= parseInt(params.adh, 10);
		dpi		= parseInt(params.dd, 10);

		// dp to px
		wpx = Math.round(width * (dpi / 160));
		hpx = Math.round(height * (dpi / 160));

		sdkv = parseFloat(params.sdkv, 10) || 1.0;

		// 后台匹配，前台只要确定px尺寸就好了
		mapping = {
			// Banner广告
			mb : {
				// desity 	：规格px，以后可能多组
				'120'	: [[240, 38]],	// ldpi
				'160'	: [[320, 50]],	// mdpi
				'213'	: [[480, 75]],	// tv
				'240'	: [[480, 75]],	// hdpi
				'320'	: [[640, 100]]	// xhdpi
				// 480
			},
			// 应用墙
			maw : {
				'120'	: [[72, 72]],	// ldpi
				'160'	: [[72, 72]],	// mdpi
				'213'	: [[72, 72]],	// tv
				'240'	: [[72, 72]],	// hdpi
				'320'	: [[72, 72]]	// xhdpi
			}
		};

		!params.adtype && (params.adtype = 'mb');
		if (!mapping[params.adtype] || ! (adsize = mapping[params.adtype][dpi])) {
			throw 'No Ad Size adapted. sdkv:'+ sdkv +', width:'+ width +', height:'+ height +', dpi:'+ dpi;
		}

		// 修正需要的广告位尺寸 @todo 以后做尺寸适配
		params.adw = adsize[0][0];
		params.adh = adsize[0][1];

		return params;
	};

	/**
	 * 分流
	 * @return {[type]} [description]
	 */
	MB._fcontrol = function() {
		var params = MB._params, rt = false,
			suffix;

		// 根据uid尾号，目前分流30%
		suffix = parseInt(params.uid.slice(-2), 16) % 100;
		if(
			suffix < 10 ||
			(suffix>=40 && suffix<50) ||
			(suffix>=90 && suffix<99)
		){
			rt = true;
		}
		return rt;
	};

	/**
	 * 供Client调用的加载广告
	 * @param  {object} params 手机参数、配置信息
	 * @return {undefined}     
	 */
	GDTMOB.loadAd = function(params) {
		var url, dpi, load,
			adtypeMapping;
		
		// 过滤下，目前只认以下参数
		params = MB._paramsFilter(params);
		// 根据设备匹配下需要的广告位规格
		params = MB._adsizeAdapter(params);

		MB._params = params;

/**
发布前开启
		// 流量控制
		if (! MB._fcontrol()) {
			MB._sendMessage('hide');
			return;
		}
**/
		// 据zoro说，山寨机可能没有这个值，js尝试来取下
		if (! params.dd) {
			dpi = window.devicePixelRatio;
			if (dpi) {
				params.dd = dpi * 160;
			} else {
				// 统计下这种异常情况
				var purl = MB._hotSend('no_desity.'+ encodeURIComponent(params.md||'unkown'), true);
				MB._sendMessage('destroy', {url:purl});
				return false;
			}
		}
		// 轮播
		params.rf = params.rf || 0;

		// 广告展现形式
		adtypeMapping = {
			'mb' : {
				type	: 'banner',
				tpl		: 'banner.html'
			},
			'maw' : {
				type	: 'appwall',
				tpl		: 'appwall.html'
			}
		};

		if (! (params.adtype in adtypeMapping)) {
			throw 'Error parameter adtype "'+ params.adtype +'"';
		}

		// 走不同模板
		// url = 'http://qzonestyle.gtimg.cn/qzone/biz/gdt/mob/sdk/html/'+ adtypeMapping[params.adtype].tpl +'#'+ MB._genHTTPParams(params);
		url = 'http://qzonestyle.gtimg.cn/qzone/biz/gdt/mob/sdk/html/'+ adtypeMapping[params.adtype].tpl +'?'+ MB._genHTTPParams(params) +'&r='+ Math.random();
// MB.console(url);

		// 附加
		MB._sendMessage('loadurl', {url: url});
	};

	/**
	 * 热点统计
	 * @param  {string} type    上报值
	 * @param  {boolean} justGen 是否仅生成上报url（不会ping），默认会发送此ping
	 * @return {boolean|undefied}
	 */
	MB._hotSend = function(type, justGen) {
		// 统计下点击关闭的人有多少
		var purl = [
			'http://pinghot.qq.com/pingd',
			'?dm=gdt.qq.com.hot',
			'&url=', escape(location.pathname),
			'&tt=-',
			'&hottag=gdtmob.display.'+ type,
			'&hotx=9999',
			'&hoty=9999',
			'&rand=', Math.random()
		].join('');

		if (justGen) {
			return purl;
		} else {
			MB._sendMessage('ping', {url: url});
		}
	};

	// 自建调试台
	MB.console = function() {
		var con = document.getElementById('console'),
			args;

		args = Array.prototype.slice.call(arguments);
		for(var i=0, l=args.length; i<l; i++) {
			if (Object.prototype.toString.call(args[i]).slice(8, -1).toLowerCase() == 'object') {
				var tmp=[];
				for(var x in args[i]) {
					tmp.push(x +':'+ args[i][x]);
				}
				args[i] = tmp.join('|');
			}
		}

		if (! con) {
			con = document.createElement('div');
			con.id = 'console';
			con.style.cssText = 'position:absolute;bottom:0;height:120px;width:100%;background:#f60;color:#fff;font-size:24px;overflow:auto';
			document.body.appendChild(con);
		}

		MB._sendMessage('show');

		con.innerHTML += '<br>'+ args.join(', ');
	};
	GDTMOB.loadAd(window['GDTMOBDATA']);
})(window.GDTMOB = window.GDTMOB || {});